<form class="form" [formGroup]="formGroup" (ngSubmit)="onSubmit()">
    <mat-form-field class="full-width" formGroupName="fields"
                *ngFor="let controlName of getControlNames()">
            <mat-label>{{controlName}}</mat-label>
            <input matInput class="form-control" [formControlName]="controlName">
    </mat-form-field>
    <button mat-button type="submit" [disabled]="!formGroup.valid">
        Submit
    </button>
</form>